using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class Card : MonoBehaviour
{
    public Texture CardBackTexture;
    public Texture CardDefaultTexture;
    public int CurrentPile = 0;
    public bool IsBlack;
    public bool defaultTextureIsSet = true;

    private Piles piles;
    private RightStacks rightStacks;
    private SoundsManager soundsManager;
    private MovesCounter movesCounter;
   
    
   
    void Awake()
	{
        CardDefaultTexture = GetComponent<Image>().texture;

        piles = GameObject.Find("Piles").GetComponent<Piles>();
        rightStacks = GameObject.Find("RightStacks").GetComponent<RightStacks>();
        soundsManager = GameObject.Find("SoundsManager").GetComponent<SoundsManager>();
        movesCounter = GameObject.Find("MovesCounter").GetComponent <MovesCounter>();

        gameObject.GetComponent<Image>().onMouseDown += Card_onMouseDown;
        gameObject.GetComponent<Image>().onMouseEnter += Card_onMouseEnter;
        gameObject.GetComponent<Image>().onMouseExit += Card_onMouseExit;

    }

    private void Card_onMouseDown(UIElement sender, int button, Vector2 cursorPosition)
    {
        //  ,     Right Stacks.
        if (piles != null)
        {
            try
            {
                if (defaultTextureIsSet == true)
                {
                    if (gameObject.name.Contains("14"))
                    {
                        rightStacks.SetAceToStack(this);
                    }
                    else
                    {
                        piles.MoveCardAtPile(this);
                    }

                    Debug.Log(gameObject.name);
                    piles.UpdatePiles();
                }
                soundsManager.PlayOnCardClickSound();
               movesCounter.UpdateMovesCounter();


            }
            catch (Exception ex)
            {
                Debug.Log(ex.Message);
            }
        }

    }
    private void Card_onMouseEnter(UIElement sender, Vector2 cursorPosition)
    {
        GetComponent<Image>().size *= 1.15f;
        soundsManager.PlayOnCardEnterSound();
    }

    private void Card_onMouseExit(UIElement sender, Vector2 cursorPosition)
    {
        GetComponent<Image>().size /= 1.15f;
    }
    public void SetCardBackTexture()
    {
        defaultTextureIsSet = false; 
        gameObject.GetComponent<Image>().texture = CardBackTexture;
    }
    public void SetCardDefaultTexture()
    {
        defaultTextureIsSet = true;
      
        gameObject.GetComponent<Image>().texture = CardDefaultTexture;
    }

}
