using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class Deck : MonoBehaviour
{
	private List<Card> cards = new List<Card>();
	private Piles piles;

	private int topMargin = 150;
	private int rightMargin = 0;


    void Awake()
    {
        piles = GameObject.Find("Piles").GetComponent<Piles>();
        cards = FindObjectsOfType<Card>().ToList();

        gameObject.GetComponent<Image>().onMouseDown += Deck_onMouseDown;
        gameObject.GetComponent<Image>().onMouseEnter += Deck_onMouseEnter;
        gameObject.GetComponent<Image>().onMouseExit  += Deck_onMouseExit;
    }

	void Start()
	{
        //    Piles.
        for (int i = 0; i < 31; i++)
        {
            TakeCard();
        }
    }


	private void TakeCard()
	{
        //   .   21   ,     Piles.  ,   .
        if (cards.Count != 0)
        {
            int rnd = FalcoEngine.Random.Range(0, cards.Count);
         
            if (cards.Count > 21)
            {
                piles.SetCardAtPile(cards[rnd]);
            }
            else
            {
                rightMargin += 20;
                cards[rnd].transform.position = gameObject.transform.localPosition + Vector3.right * rightMargin - Vector3.up * topMargin;

                Transform defParent = transform.parent;
                cards[rnd].transform.parent = GameObject.Find("SoundsManager").transform;
                cards[rnd].transform.parent = defParent;
            }
            cards.RemoveAt(rnd);
        }
    }
    private void Deck_onMouseDown(UIElement sender, int button, Vector2 cursorPosition)
    {
        try
        {
            TakeCard();
        }
        catch (Exception ex) { Debug.Log(ex.Message); }
    }
    private void Deck_onMouseEnter(UIElement sender, Vector2 cursorPosition)
    {
        GetComponent<Image>().size *= 1.15f;
    }
    private void Deck_onMouseExit(UIElement sender, Vector2 cursorPosition)
    {
        GetComponent<Image>().size /= 1.15f;
    }
}
