using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class Piles : MonoBehaviour
{
    public RightStacks rightStacks;
    public GameObject Pile1;
	public GameObject Pile2;
	public GameObject Pile3;
	public GameObject Pile4;
	public GameObject Pile5;
	public GameObject Pile6;
	public GameObject Pile7;

	private GameObject[] piles=  new GameObject[7];
  

	void Awake()
	{
        piles[0] = Pile1;
        piles[1] = Pile2;
        piles[2] = Pile3;
        piles[3] = Pile4;
        piles[4] = Pile5;
        piles[5] = Pile6;
        piles[6] = Pile7;
    }

	
	public void SetCardAtPile(Card card)
	{
        for (int i = 0; i < piles.Length; i++)
		{
            
            if (!(piles[i].transform.childCount > i))
			{
				if (piles[i].transform.childCount == i)
				{
					card.SetCardDefaultTexture();
				}
				else
				{
					card.SetCardBackTexture();
				}

				card.transform.parent = piles[i].transform;
				card.transform.position = piles[i].transform.position + Vector3.up * (piles[i].transform.childCount * (186 / 6));
                card.CurrentPile = i;
				break;
            }

		}
	}

    public void MoveCardAtPile(Card card)
    {
        if (rightStacks.trySetToStack(card) == false) 
        {
            for (int i = 0; i < piles.Length; i++)
            {
                if (piles[i].transform.childCount != 0)
                {
                    string lastCardName = piles[i].transform.GetChild(piles[i].transform.childCount - 1).gameObject.name;

                    if (piles[i].transform.GetChild(piles[i].transform.childCount - 1).gameObject.GetComponent<Card>().IsBlack == true)
                    {
                        if (card.IsBlack == false)
                        {
                            if (int.Parse(lastCardName.Substring(1)) == int.Parse(card.name.Substring(1)) + 1)
                            {
                                card.CurrentPile = i;
                                //card.transform.parent = GameObject.Find("GameManager").transform;
                                card.transform.parent = piles[i].transform;

                                //card.transform.position = piles[i].transform.position + Vector3.up * (piles[i].transform.childCount * 31);
                                break;
                            }
                        }

                    }
                    else if (piles[i].transform.GetChild(piles[i].transform.childCount - 1).gameObject.GetComponent<Card>().IsBlack == false)
                    {
                        if (card.IsBlack == true)
                        {
                            if (int.Parse(lastCardName.Substring(1)) == int.Parse(card.name.Substring(1)) + 1)
                            {
                                card.CurrentPile = i;
                                card.transform.parent = piles[i].transform;


                                //card.transform.position = piles[i].transform.position + Vector3.up * (piles[i].transform.childCount * 31);
                                break;
                            }
                        }
                    }
                }
                else if (card.gameObject.name.Substring(1)=="13")
                {
                    card.CurrentPile = i;
                    card.transform.parent = piles[i].transform;
                    //card.transform.position = piles[i].transform.position + Vector3.up * (piles[i].transform.childCount * 31);
                }

            }
        }
     
        
    }

    public void UpdatePiles()
    {
        for (int i = 0; i < piles.Length; i++)
        {
            int yMargin = 31;
            for (int j = 0; j < piles[i].transform.childCount; j++)
            {
                piles[i].transform.GetChild(j).position = piles[i].transform.position+Vector3.up*yMargin;
                yMargin += 31;
            }

            if (piles[i].transform.childCount != 0)
            {
                if (piles[i].transform.GetChild(piles[i].transform.childCount - 1).gameObject.GetComponent<Card>().defaultTextureIsSet == false)
                {
                    piles[i].transform.GetChild(piles[i].transform.childCount - 1).gameObject.GetComponent<Card>().SetCardDefaultTexture();
                }
            }
        }
    }

   
}
